;-------------------------------------------------------------
;    PolySnd: Fonctions sonores
;		par Geoffrey ANNEHEIM
;	Grand Merci  Laurent PONCEY pour son programme Sound6d	
;-------------------------------------------------------------

PolySnd::PlayStereoSound		equ	polysnd@0000
;--------------------------------------------------------------
;PlayStereoSound(Table des frquences,Morceau 1,Morceau 2,Tps1,Tps2,UnitTps)
;
;   Joue une musique au format stro soit Morceau 1 correspond  l'couteur
;   gauche et morceau 2  l'couteur droit.
;   La table des frquences correspond au frquence de chaque notes de musique.
;   Tps1 dure ajoute  la dure de la note en cours du morceau 1.
;   Tps2 dure ajoute  la dure de la note en cours du morceau 2.
;   UnitTps rptiton (Tempo)
;   TI-92=0h5000.
;
;Input:	a1.l = Morceau 1 soit couteur Gauche		lea	morc1(PC),a1
;	a2.l = Morceau 2 soit couteur Droit		lea	morc2(PC),a2
;	d0.w = tps1 en Hexadcimal			move.w	#$0,d0
;	d1.w = tps2 en Hexadcimal			move.w	#$0,d1		
;	d2.w = unittps en Hexadcimal			move.w	#$5000,d2	move.w Tempo_120,d2
;
;Output: nothing
;	ALL REGISTERS DESTROYED
;--------------------------------------------------------------

;******************************************************
;Enumration des notes par octaves  la norme Franaise
;******************************************************

;------------
;| OCTAVE 0 |
;------------

do_0		EQU	$8c
do#_0		EQU	$8b
reb_0		EQU	$8b
re_0		EQU	$8a
re#_0		EQU	$89
mib_0		EQU	$89
mi_0		EQU	$88
fa_0		EQU	$87
fa#_0		EQU	$86
solb_0		EQU	$86
sol_0		EQU	$85
sol#_0		EQU	$84
lab_0		EQU	$84
la_0		EQU	$83
la#_0		EQU	$82
sib_0		EQU	$82
si_0		EQU	$81

 
;------------
;| OCTAVE 1 |
;------------

do_1		EQU	$7c
do#_1		EQU	$7b
reb_1		EQU	$7b
re_1		EQU	$7a
re#_1		EQU	$79
mib_1		EQU	$79
mi_1		EQU	$78
fa_1		EQU	$77
fa#_1		EQU	$76
solb_1		EQU	$76
sol_1		EQU	$75
sol#_1		EQU	$74
lab_1		EQU	$74
la_1		EQU	$73
la#_1		EQU	$72
sib_1		EQU	$72
si_1		EQU	$71


;------------
;| OCTAVE 2 |
;------------

do_2		EQU	$6c
do#_2		EQU	$6b
reb_2		EQU	$6b
re_2		EQU	$6a
re#_2		EQU	$69
mib_2		EQU	$69
mi_2		EQU	$68
fa_2		EQU	$67
fa#_2		EQU	$66
solb_2		EQU	$66
sol_2		EQU	$65
sol#_2		EQU	$64
lab_2		EQU	$64
la_2		EQU	$63
la#_2		EQU	$62
sib_2		EQU	$62
si_2		EQU	$61


;------------
;| OCTAVE 3 |
;------------

do_3		EQU	$5c
do#_3		EQU	$5b
reb_3		EQU	$5b
re_3		EQU	$5a
re#_3		EQU	$59
mib_3		EQU	$59
mi_3		EQU	$58
fa_3		EQU	$57
fa#_3		EQU	$56
solb_3		EQU	$56
sol_3		EQU	$55
sol#_3		EQU	$54
lab_3		EQU	$54
la_3		EQU	$53
la#_3		EQU	$52
sib_3		EQU	$52
si_3		EQU	$51


;------------
;| OCTAVE 4 |
;------------

do_4		EQU	$4c
do#_4		EQU	$4b
reb_4		EQU	$4b
re_4		EQU	$4a
re#_4		EQU	$49
mib_4		EQU	$49
mi_4		EQU	$48
fa_4		EQU	$47
fa#_4		EQU	$46
solb_4		EQU	$46
sol_4		EQU	$45
sol#_4		EQU	$44
lab_4		EQU	$44
la_4		EQU	$43
la#_4		EQU	$42
sib_4		EQU	$42
si_4		EQU	$41


;------------
;| OCTAVE 5 |
;------------

do_5		EQU	$3c
do#_5		EQU	$3b
reb_5		EQU	$3b
re_5		EQU	$3a
re#_5		EQU	$39
mib_5		EQU	$39
mi_5		EQU	$38
fa_5		EQU	$37
fa#_5		EQU	$36
solb_5		EQU	$36
sol_5		EQU	$35
sol#_5		EQU	$34
lab_5		EQU	$34
la_5		EQU	$33
la#_5		EQU	$32
sib_5		EQU	$32
si_5		EQU	$31


;------------
;| OCTAVE 6|
;------------

do_6		EQU	$2c
do#_6		EQU	$2b
reb_6		EQU	$2b
re_6		EQU	$2a
re#_6		EQU	$29
mib_6		EQU	$29
mi_6		EQU	$28
fa_6		EQU	$27
fa#_6		EQU	$26
solb_6		EQU	$26
sol_6		EQU	$25
sol#_6		EQU	$24
lab_6		EQU	$24
la_6		EQU	$23
la#_6		EQU	$22
sib_6		EQU	$22
si_6		EQU	$21


;------------
;| OCTAVE 7 |
;------------

do_7		EQU	$1c
do#_7		EQU	$1b
reb_7		EQU	$1b
re_7		EQU	$1a
re#_7		EQU	$19
mib_7		EQU	$19
mi_7		EQU	$18
fa_7		EQU	$17
fa#_7		EQU	$16
solb_7		EQU	$16
sol_7		EQU	$15
sol#_7		EQU	$14
lab_7		EQU	$14
la_7		EQU	$13
la#_7		EQU	$12
sib_7		EQU	$12
si_7		EQU	$11


;*******************************************************
;Enumration des notes par octaves sous forme de lettres
;*******************************************************

;------------
;| OCTAVE 0 |
;------------

C_0		EQU	$8c
C#_0		EQU	$8b
Db_0		EQU	$8b
D_0		EQU	$8a
D#_0		EQU	$89
Eb_0		EQU	$89
E_0		EQU	$88
F_0		EQU	$87
F#_0		EQU	$86
Gb_0		EQU	$86
G_0		EQU	$85
G#_0		EQU	$84
Ab_0		EQU	$84
A_0		EQU	$83
A#_0		EQU	$82
Bb_0		EQU	$82
B_0		EQU	$81 
 
;------------
;| OCTAVE 1 |
;------------

C_1		EQU	$7c
C#_1		EQU	$7b
Db_1		EQU	$7b
D_1		EQU	$7a
D#_1		EQU	$79
Eb_1		EQU	$79
E_1		EQU	$78
F_1		EQU	$77
F#_1		EQU	$76
Gb_1		EQU	$76
G_1		EQU	$75
G#_1		EQU	$74
Ab_1		EQU	$74
A_1		EQU	$73
A#_1		EQU	$72
Bb_1		EQU	$72
B_1		EQU	$71


;------------
;| OCTAVE 2 |
;------------

C_2		EQU	$6c
C#_2		EQU	$6b
Db_2		EQU	$6b
D_2		EQU	$6a
D#_2		EQU	$69
Eb_2		EQU	$69
E_2		EQU	$68
F_2		EQU	$67
F#_2		EQU	$66
Gb_2		EQU	$66
G_2		EQU	$65
G#_2		EQU	$64
Ab_2		EQU	$64
A_2		EQU	$63
A#_2		EQU	$62
Bb_2		EQU	$62
B_2		EQU	$61


;------------
;| OCTAVE 3|
;------------

C_3		EQU	$5c
C#_3		EQU	$5b
Cb_3		EQU	$5b
D_3		EQU	$5a
D#_3		EQU	$59
Eb_3		EQU	$59
E_3		EQU	$58
F_3		EQU	$57
F#_3		EQU	$56
Gb_3		EQU	$56
G_3		EQU	$55
G#_3		EQU	$54
Ab_3		EQU	$54
A_3		EQU	$53
A#_3		EQU	$52
Bb_3		EQU	$52
B_3		EQU	$51


;------------
;| OCTAVE 4 |
;------------

C_4		EQU	$4c
C#_4		EQU	$4b
Db_4		EQU	$4b
D_4		EQU	$4a
D#_4		EQU	$49
Eb_4		EQU	$49
E_4		EQU	$48
F_4		EQU	$47
F#_4		EQU	$46
Gb_4		EQU	$46
G_4		EQU	$45
G#_4		EQU	$44
Ab_4		EQU	$44
A_4		EQU	$43
A#_4		EQU	$42
Bb_4		EQU	$42
B_4		EQU	$41

;------------
;| OCTAVE 5 |
;------------

C_5		EQU	$3c
C#_5		EQU	$3b
Db_5		EQU	$3b
D_5		EQU	$3a
D#_5		EQU	$39
Eb_5		EQU	$39
E_5		EQU	$38
F_5		EQU	$37
F#_5		EQU	$36
Gb_5		EQU	$36
G_5		EQU	$35
G#_5		EQU	$34
Ab_5		EQU	$34
A_5		EQU	$33
A#_5		EQU	$32
Bb_5		EQU	$32
B_5		EQU	$31

;------------
;| OCTAVE 6 |
;------------

C_6		EQU	$2c
C#_6		EQU	$2b
Db_6		EQU	$2b
D_6		EQU	$2a
D#_6		EQU	$29
Eb_6		EQU	$29
E_6		EQU	$28
F_6		EQU	$27
F#_6		EQU	$26
Gb_6		EQU	$26
G_6		EQU	$25
G#_6		EQU	$24
Ab_6		EQU	$24
A_6		EQU	$23
A#_6		EQU	$22
Bb_6		EQU	$22
B_6		EQU	$21


;------------
;| OCTAVE 7 |
;------------

C_7		EQU	$1c
C#_7		EQU	$1b
Db_7		EQU	$1b
D_7		EQU	$1a
D#_7		EQU	$19
Eb_7		EQU	$19
E_7		EQU	$18
F_7		EQU	$17
F#_7		EQU	$16
Gb_7		EQU	$16
G_7		EQU	$15
G#_7		EQU	$14
Ab_7		EQU	$14
A_7		EQU	$13
A#_7		EQU	$12
Bb_7		EQU	$12
B_7		EQU	$11


;***********************************************************
;Enumration des notes par octaves sous forme de lettres n2
;***********************************************************

;------------
;| OCTAVE 0 |
;------------

_c0		EQU	$8c
_cs0		EQU	$8b
_db0		EQU	$8b
_d0		EQU	$8a
_ds0		EQU	$89
_eb0		EQU	$89
_e0		EQU	$88
_f0		EQU	$87
_fs0		EQU	$86
_gb0		EQU	$86
_g0		EQU	$85
_gs0		EQU	$84
_ab0		EQU	$84
_a0		EQU	$83
_as0		EQU	$82
_bb0		EQU	$82
_b0		EQU	$81
 
;------------
;| OCTAVE 1 |
;------------

_c1		EQU	$7c
_cs1		EQU	$7b
_db1		EQU	$7b
_d1		EQU	$7a
_ds1		EQU	$79
_eb1		EQU	$79
_e1		EQU	$78
_f1		EQU	$77
_fs1		EQU	$76
_gb1		EQU	$76
_g1		EQU	$75
_gs1		EQU	$74
_ab1		EQU	$74
_a1		EQU	$73
_as1		EQU	$72
_bb1		EQU	$72
_b1		EQU	$71


;------------
;| OCTAVE 2 |
;------------

_c2		EQU	$6c
_cs2		EQU	$6b
_db2		EQU	$6b
_d2		EQU	$6a
_ds2		EQU	$69
_eb2		EQU	$69
_e2		EQU	$68
_f2		EQU	$67
_fs2		EQU	$66
_gb2		EQU	$66
_g2		EQU	$65
_gs2		EQU	$64
_ab2		EQU	$64
_a2		EQU	$63
_as2		EQU	$62
_bb2		EQU	$62
_b2		EQU	$61


;------------
;| OCTAVE 3 |
;------------

_c3		EQU	$5c
_cs3		EQU	$5b
_cb3		EQU	$5b
_d3		EQU	$5a
_ds3		EQU	$59
_eb3		EQU	$59
_e3		EQU	$58
_f3		EQU	$57
_fs3		EQU	$56
_gb3		EQU	$56
_g3		EQU	$55
_gs3		EQU	$54
_ab3		EQU	$54
_a3		EQU	$53
_as3		EQU	$52
_bb3		EQU	$52
_b3		EQU	$51


;------------
;| OCTAVE 4 |
;------------

_c4		EQU	$4c
_cs4		EQU	$4b
_db4		EQU	$4b
_d4		EQU	$4a
_ds4		EQU	$49
_eb4		EQU	$49
_e4		EQU	$48
_f4		EQU	$47
_fs4		EQU	$46
_gb4		EQU	$46
_g4		EQU	$45
_gs4		EQU	$44
_ab4		EQU	$44
_a4		EQU	$43
_as4		EQU	$42
_bb4		EQU	$42
_b4		EQU	$41


;------------
;| OCTAVE 5 |
;------------

_c5		EQU	$3c
_cs5		EQU	$3b
_db5		EQU	$3b
_d5		EQU	$3a
_ds5		EQU	$39
_eb5		EQU	$39
_e5		EQU	$38
_f5		EQU	$37
_fs5		EQU	$36
_gb5		EQU	$36
_g5		EQU	$35
_gs5		EQU	$34
_ab5		EQU	$34
_a5		EQU	$33
_as5		EQU	$32
_bb5		EQU	$32
_b5		EQU	$31


;------------
;| OCTAVE 6 |
;------------

_c6		EQU	$2c
_cs6		EQU	$2b
_db6		EQU	$2b
_d6		EQU	$2a
_ds6		EQU	$29
_eb6		EQU	$29
_e6		EQU	$28
_f6		EQU	$27
_fs6		EQU	$26
_gb6		EQU	$26
_g6		EQU	$25
_gs6		EQU	$24
_ab6		EQU	$24
_a6		EQU	$23
_as6		EQU	$22
_bb6		EQU	$22
_b6		EQU	$21


;------------
;| OCTAVE 7 |
;------------

_c7		EQU	$1c
_cs7		EQU	$1b
_db7		EQU	$1b
_d7		EQU	$1a
_ds7		EQU	$19
_eb7		EQU	$19
_e7		EQU	$18
_f7		EQU	$17
_fs7		EQU	$16
_gb7		EQU	$16
_g7		EQU	$15
_gs7		EQU	$14
_ab7		EQU	$14
_a7		EQU	$13
_as7		EQU	$12
_bb7		EQU	$12
_b7		EQU	$11

pause		EQU	$00	;pause est pris en compte comme une note.
rest		EQU	$00

;*****************************************************************************
;La plupart des morceaux de musique utilisent les tempos suivant. Mais si vous
;voulez crer un tempo ne figurant pas dans la liste voici la procdure:
;
;120/par votre tempo=indice
;valeur du tempo 120 (7376)*indice=valeur du tempo en dcimal.
;Il ne vous reste qu' convertir la valeur dcimal en hexadcimal grce  la
;calculatrice fournie par windows.
;
;exemple:
;********
;
;votre tempo=94
;120/94=1.2766
;7376*1.2766=9416
;9416=24C8 en hexadcimal
;
;
;Instruction:
;------------
;
;move.w	#9416,d2 ou move.w #$24C8,d2
;
;
;Attention si votre nombre hexadcimal est infrieur  1000 (4096) ou est
;suprieur  FFFF (65535), le programme ne fonctionnera pas correctement.
;*****************************************************************************

Tempo_220	dc.w	$0FB8	;soit 4023
		even
Tempo_180	dc.w	$1335	;soit 4917
		even
Tempo_152	dc.w	$16BF	;soit 5823
		even
Tempo_140	dc.w	$18B2	;soit 6322
		even
Tempo_136	dc.w	$196C	;soit 6508
		even
Tempo_120	dc.w	$1CD0	;soit 7376
		even
Tempo_116	dc.w	$1DCE	;soit 7630
		even
Tempo_112	dc.w	$1EDF	;soit 7903
		even
Tempo_104	dc.w	$213F	;soit 8511
		even
Tempo_96	dc.w	$2404	;soit 9220
		even
Tempo_92	dc.w	$2595	;soit 9621
		even
Tempo_88	dc.w	$274A	;soit 10058
		even
Tempo_80	dc.w	$2B38	;soit 11064
		even
Tempo_72	dc.w	$3005	;soit 12293
		even

;*****************************************************************************
;Voici la liste des dure. Cette liste peut tre modifi.
;Par dfaut 30=noir.
;Dures talonnes avec prcision en fonction du tempo.
;
;Ronde = 4 temps
;Blanche = 2 temps
;Blanche pointe = 2+1/2
;Noir pointe = 1+1/2 temps
;Noir = 1 temps
;Croche pointe = 1/2+1/4 temps
;Croche = 1/2 temps
;Double croche = 1/4 temps
;Triple croche = 1/8 temps
;Triolet = 1/3 temps
;*****************************************************************************

_r		EQU	120
_bp		EQU	75
_b		EQU	60
_np		EQU	45	
_n		EQU	30
_cp		EQU	22
_c		EQU	15
_cc		EQU	7
_ccc		EQU	4
_cccc		EQU	2
_tri		EQU	10

ronde		EQU	120
blanche_pointe	EQU	75
blanche		EQU	60
noir_pointe	EQU	45	
noir		EQU	30
croche_pointe	EQU	22
croche		EQU	15
double_croche	EQU	7
triple_croche	EQU	4
quadruple_croche EQU	2

_soupir		EQU	30
_soupirp	EQU	45
soupir		EQU	30
soupir_point	EQU	45

whole		EQU	120	;Ronde
half		EQU	60	;Blanche
quarter		EQU	30	;Noir
eighth		EQU	15	;Croche
sixteenth	EQU	7	;Double croche
thirtysecond	EQU	4	;Triple croche
sixtyfourth	EQU	2	;Quadruple croche

half3		EQU	20
quarter3	EQU	10
eighth3		EQU	5
sixteenth3	EQU	2
thirtysecond3	EQU	1
sixtyfourth3	EQU	0